package org.eclipse.stp.core.projectintrospection;

import java.util.List;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.stp.core.introspection.AbstractComponentTypeIntrospector;
import org.eclipse.stp.core.introspection.IComponentTypeIntrospector;
import org.eclipse.stp.core.sca.JavaInterface;
import org.eclipse.stp.core.sca.SCAFactory;
import org.eclipse.stp.core.sca.SCAPackage;
import org.eclipse.stp.core.sca.Service;

public class ProjectComponentTypeIntrospector extends
		AbstractComponentTypeIntrospector implements IComponentTypeIntrospector {

	@Override
	protected IStatus doIntrospection(int theFieldType, List theCurrentValues) {
		switch (theFieldType) {
		case SCAPackage.COMPONENT_TYPE__SERVICES:
            introspectServices(theCurrentValues);
            break;
         case SCAPackage.COMPONENT_TYPE__PROPERTIES:
            introspectProperties(theCurrentValues);
            break;
         case SCAPackage.COMPONENT_TYPE__REFERENCES:
            introspectReferences(theCurrentValues);
            break;
     }
     return Status.OK_STATUS;
	}

	private void introspectReferences(List theCurrentValues) {
		
	}

	private void introspectProperties(List theCurrentValues) {
		
	}

	private void introspectServices(List theCurrentValues) {
		// Add service
		Service service = SCAFactory.eINSTANCE.createService();
		service.setName("Service1");

		JavaInterface jInterface = SCAFactory.eINSTANCE.createJavaInterface();
		jInterface.setInterface("interfaze1");

		service.setInterface(jInterface);
		theCurrentValues.add(service) ;
	}

	public IStatus dispose() {
		return Status.OK_STATUS;
	}

	public IStatus hasValidComponentType() {
		return Status.OK_STATUS;
	}

	public IStatus onModelChange(int theFieldType, int theChangeType,
			Object theChangedObject) {
		return Status.OK_STATUS;
	}

	public Object resolveImplementation() {
		return null;
	}

	public IStatus save() {
		return Status.OK_STATUS;
	}

}
