package org.eclipse.stp.core.projectintrospection.popup.actions;

import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.stp.core.infrastructure.emf.EditModelException;
import org.eclipse.stp.core.infrastructure.emf.IEditModelScribbler;
import org.eclipse.stp.core.resources.ComponentTypeScribblerDomain;
import org.eclipse.stp.core.sca.ComponentType;
import org.eclipse.stp.core.sca.SCACoreRoot;
import org.eclipse.stp.core.sca.Service;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

public class NewAction implements IObjectActionDelegate {

	
	/**
	 * Constructor for Action1.
	 */
	public NewAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		ComponentType cptType = null;
		// get .project file from first project in workspace
		ComponentTypeScribblerDomain domain = new ComponentTypeScribblerDomain(
				ResourcesPlugin.getWorkspace().getRoot().getProjects()[0]
						.getFile(".project"));

		IEditModelScribbler scribbler;
		String message = "ComponentType Introspection" ;
		try {
			scribbler = domain.createScribblerForRead();

			Resource r = scribbler.getResource(domain
					.getComponentTypeDescriptor());

			if (r.getContents().size() > 0) {

				Object rootObject = r.getContents().get(0);

				if (rootObject instanceof SCACoreRoot) {

					SCACoreRoot root = (SCACoreRoot) r.getContents().get(0);

					cptType = root.getComponentType();
					if(cptType.getServices().size() > 0 ){
						Service service = (Service)cptType.getServices().get(0) ;
						message = "Component Type has "+cptType.getServices().size()+" Services"+
									" Name of the first Service is "+service.getName() ;
					}
				}
			}
		} catch (EditModelException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Shell shell = new Shell();
		MessageDialog.openInformation(shell, "ProjectIntrospection Plug-in",
				message);
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
	}

}
